prereq.sh 25 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965
  1. #!/bin/sh
  2. # This file is part of the OpenADK project. OpenADK is copyrighted
  3. # material, please see the LICENCE file in the top-level directory.
  4. #set -x
  5. # resolve prerequisites for OpenADK build
  6. topdir=$(pwd)
  7. target="$@"
  8. flags="$MAKEFLAGS"
  9. out=0
  10. mirror=https://distfiles.openadk.org
  11. makever=4.2.1
  12. bashver=4.4.18
  13. # detect operating system
  14. os=$(env uname)
  15. osver=$(env uname -r)
  16. printf " ---> $os $osver for build detected.\n"
  17. # check if the filesystem is case sensitive
  18. rm -f foo
  19. echo >FOO
  20. if [ -e foo ]; then
  21. printf "ERROR: OpenADK cannot be built in a case-insensitive file system.\n"
  22. case $os in
  23. CYG*)
  24. printf "Building OpenADK on $os needs a small registry change.\n"
  25. printf "http://cygwin.com/cygwin-ug-net/using-specialnames.html\n"
  26. ;;
  27. Darwin*)
  28. printf "Building OpenADK on $os needs a case-sensitive disk partition.\n"
  29. printf "For Snow Leopard and above you can use diskutil to resize your existing disk.\n"
  30. printf "Example: sudo diskutil resizeVolume disk0s2 90G 1 jhfsx adk 30G\n"
  31. printf "For older versions you might consider to use a disk image:\n"
  32. printf "hdiutil create -type SPARSE -fs 'Case-sensitive Journaled HFS+' -size 30g ~/openadk.dmg\n"
  33. ;;
  34. esac
  35. rm -f FOO
  36. exit 1
  37. fi
  38. rm -f FOO
  39. # do we have a download tool?
  40. tools="curl wget"
  41. for tool in $tools; do
  42. printf " ---> checking if $tool is installed.. "
  43. if which $tool >/dev/null; then
  44. printf "found\n"
  45. case $tool in
  46. curl)
  47. FETCHCMD="$(which $tool) --progress-bar -L -k -f -o "
  48. ;;
  49. wget)
  50. FETCHCMD="$(which $tool) -t2 --no-check-certificate -O "
  51. ;;
  52. esac
  53. break
  54. else
  55. printf "not found\n"
  56. continue
  57. fi
  58. done
  59. if [ -z "$FETCHCMD" ]; then
  60. printf "ERROR: no download tool found. Fatal error.\n"
  61. exit 1
  62. fi
  63. # do we have a checksum tool?
  64. tools="sha256sum sha256 cksum shasum"
  65. for tool in $tools; do
  66. printf " ---> checking if $tool is installed.. "
  67. if which $tool >/dev/null 2>/dev/null; then
  68. printf "found\n"
  69. # check if cksum is usable
  70. case $tool in
  71. sha256sum)
  72. SHA256=$(which $tool)
  73. ;;
  74. sha256)
  75. SHA256="$(which $tool) -q"
  76. ;;
  77. cksum)
  78. if cksum -t >/dev/null 2>/dev/null; then
  79. SHA256="$(which $tool) -q -a sha256"
  80. else
  81. continue
  82. fi
  83. ;;
  84. shasum)
  85. SHA256="$(which $tool) -a 256"
  86. ;;
  87. esac
  88. break
  89. else
  90. printf "not found\n"
  91. continue
  92. fi
  93. done
  94. if [ -z "$SHA256" ]; then
  95. printf "ERROR: no checksum tool found. Fatal error.\n"
  96. exit 1
  97. fi
  98. # create download dir
  99. if [ ! -d $topdir/dl ]; then
  100. mkdir -p $topdir/dl
  101. fi
  102. # check for c compiler
  103. if [ $os = "Darwin" ]; then
  104. compilerbins="clang cc gcc"
  105. else
  106. compilerbins="cc gcc clang"
  107. fi
  108. for compilerbin in $compilerbins; do
  109. printf " ---> checking if $compilerbin is installed.. "
  110. if which $compilerbin >/dev/null; then
  111. printf "found\n"
  112. CC=$compilerbin
  113. CCFOUND=1
  114. break
  115. else
  116. printf "not found\n"
  117. continue
  118. fi
  119. done
  120. if [ -z "$CCFOUND" ]; then
  121. printf "ERROR: no C compiler found. Fatal error.\n"
  122. exit 1
  123. fi
  124. # check for c++ compiler
  125. if [ $os = "Darwin" ]; then
  126. compilerbins="clang++ c++ g++"
  127. else
  128. compilerbins="c++ g++ clang++"
  129. fi
  130. for compilerbin in $compilerbins; do
  131. printf " ---> checking if $compilerbin is installed.. "
  132. if which $compilerbin >/dev/null; then
  133. printf "found\n"
  134. CXX=$compilerbin
  135. CXXFOUND=1
  136. break
  137. else
  138. printf "not found\n"
  139. continue
  140. fi
  141. done
  142. if [ -z "$CXXFOUND" ]; then
  143. printf "ERROR: no C++ compiler found. Fatal error.\n"
  144. exit 1
  145. fi
  146. gnu_host_name=$(${CC} -dumpmachine)
  147. # relocation of topdir?
  148. olddir=$(grep "^ADK_TOPDIR" prereq.mk 2>/dev/null |cut -d '=' -f 2)
  149. newdir=$(pwd)
  150. if [ ! -z "$olddir" ]; then
  151. if [ "$olddir" != "$newdir" ]; then
  152. printf " ---> adk directory was relocated, fixing .."
  153. sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.pc 2>/dev/null|xargs) 2>/dev/null
  154. sed -i -e "s#$olddir#$newdir#g" $(find host_${gnu_host_name} -type f 2>/dev/null|xargs) 2>/dev/null
  155. sed -i -e "s#$olddir#$newdir#g" $(find target_*/scripts -type f 2>/dev/null|xargs) 2>/dev/null
  156. sed -i -e "s#$olddir#$newdir#" target_*/etc/ipkg.conf 2>/dev/null
  157. sleep 1
  158. printf "done\n"
  159. fi
  160. fi
  161. case :$PATH: in
  162. (*:$topdir/host_${gnu_host_name}/bin:*) ;;
  163. (*) export PATH=$topdir/host_${gnu_host_name}/bin:$PATH ;;
  164. esac
  165. # check for GNU make
  166. makebins="gmake make"
  167. for makebin in $makebins; do
  168. printf " ---> checking if $makebin is installed.. "
  169. if which $makebin >/dev/null 2>/dev/null; then
  170. printf "found\n"
  171. printf " ---> checking if it is GNU make.. "
  172. $makebin --version 2>/dev/null| grep GNU >/dev/null
  173. if [ $? -eq 0 ]; then
  174. printf "yes\n"
  175. MAKE=$(which $makebin)
  176. fi
  177. printf " ---> checking if it is make 4.x.. "
  178. LC_ALL=C $makebin --version 2>/dev/null| grep -i "Make 4" >/dev/null
  179. if [ $? -eq 0 ]; then
  180. printf "yes\n"
  181. break
  182. else
  183. # we need to build GNU make
  184. printf "no\n"
  185. printf " ---> compiling missing GNU make.. "
  186. cd dl
  187. $FETCHCMD make-${makever}.tar.gz $mirror/make-${makever}.tar.gz
  188. if [ $? -ne 0 ]; then
  189. printf "ERROR: failed to download make from $mirror\n"
  190. exit 1
  191. fi
  192. cd ..
  193. mkdir tmp
  194. cd tmp
  195. tar xzf ../dl/make-${makever}.tar.gz
  196. cd make-$makever
  197. ./configure --prefix=$topdir/host_$gnu_host_name
  198. make
  199. make install
  200. cd ..
  201. cd ..
  202. rm -rf tmp
  203. (cd $topdir/host_$gnu_host_name/bin/; ln -sf make gnumake)
  204. MAKE=$topdir/host_$gnu_host_name/bin/make
  205. makebin=$topdir/host_$gnu_host_name/bin/make
  206. printf " done\n"
  207. fi
  208. else
  209. printf "not found\n"
  210. continue
  211. fi
  212. done
  213. # check for bash
  214. printf " ---> checking if bash is installed.. "
  215. if which bash >/dev/null; then
  216. printf "found\n"
  217. printf " ---> checking if it is bash 4.x or 5.x.. "
  218. LC_ALL=C bash --version 2>/dev/null| egrep -i 'version 4|5' >/dev/null
  219. if [ $? -eq 0 ]; then
  220. printf "yes\n"
  221. else
  222. # we need to build GNU bash 4.x
  223. printf "not found\n"
  224. printf " ---> compiling missing GNU bash.. "
  225. cd dl
  226. $FETCHCMD bash-${bashver}.tar.gz $mirror/bash-${bashver}.tar.gz
  227. if [ $? -ne 0 ]; then
  228. printf "ERROR: failed to download make from $mirror\n"
  229. exit 1
  230. fi
  231. cd ..
  232. mkdir tmp
  233. cd tmp
  234. tar xzf ../dl/bash-${bashver}.tar.gz
  235. cd bash-${bashver}
  236. ./configure --prefix=$topdir/host_$gnu_host_name/
  237. make
  238. make install
  239. cd ..
  240. cd ..
  241. rm -rf tmp
  242. printf " done\n"
  243. fi
  244. fi
  245. # skip the script if distclean / cleandir
  246. if [ "$target" = "distclean" -o "$target" = "cleandir" ]; then
  247. touch prereq.mk
  248. $makebin ADK_TOPDIR=$topdir -s -f Makefile.adk $flags $target
  249. exit 0
  250. fi
  251. printf " ---> checking if strings is installed.. "
  252. if ! which strings >/dev/null 2>&1; then
  253. echo You must install strings to continue.
  254. echo
  255. out=1
  256. printf "not found\n"
  257. fi
  258. printf "found\n"
  259. printf " ---> checking if perl is installed.. "
  260. if ! which perl >/dev/null 2>&1; then
  261. echo You must install perl to continue.
  262. echo
  263. out=1
  264. printf "not found\n"
  265. fi
  266. printf "found\n"
  267. printf " ---> checking if gzip is installed.. "
  268. if ! which gzip >/dev/null 2>&1; then
  269. echo You must install gzip to continue.
  270. echo
  271. out=1
  272. printf "not found\n"
  273. fi
  274. printf "found\n"
  275. printf " ---> checking if git is installed.. "
  276. if ! which git >/dev/null 2>&1; then
  277. echo You must install git to continue.
  278. echo
  279. out=1
  280. printf "not found\n"
  281. fi
  282. printf "found\n"
  283. printf " ---> checking if ncurses is installed.. "
  284. check_lxdialog=${topdir}/adk/config/lxdialog/check-lxdialog.sh
  285. CURSES_CFLAGS=$(/bin/sh ${check_lxdialog} -ccflags | tr '\n' ' ')
  286. CURSES_LIBS=$(/bin/sh ${check_lxdialog} -ldflags ${CC})
  287. if [ $? -eq 0 ]; then
  288. printf "found\n"
  289. else
  290. printf "not found\n"
  291. out=1
  292. fi
  293. # creating prereq.mk
  294. echo "ADK_TOPDIR:=$(readlink -nf . 2>/dev/null || pwd -P)" > $topdir/prereq.mk
  295. echo "BASH:=$(which bash)" >> $topdir/prereq.mk
  296. echo "SHELL:=$(which bash)" >> $topdir/prereq.mk
  297. echo "GMAKE:=$MAKE" >> $topdir/prereq.mk
  298. echo "MAKE:=$MAKE" >> $topdir/prereq.mk
  299. echo "FETCHCMD:=$FETCHCMD" >> $topdir/prereq.mk
  300. echo "SHA256:=$SHA256" >> $topdir/prereq.mk
  301. echo "GNU_HOST_NAME:=${gnu_host_name}" >> $topdir/prereq.mk
  302. echo "OS_FOR_BUILD:=${os}" >> $topdir/prereq.mk
  303. echo "ARCH_FOR_BUILD:=$(${CC} -dumpmachine | sed \
  304. -e 's/x86_64-linux-gnux32/x32/' \
  305. -e s'/-.*//' \
  306. -e 's/sparc.*/sparc/' \
  307. -e 's/armeb.*/armeb/g' \
  308. -e 's/arm.*/arm/g' \
  309. -e 's/m68k.*/m68k/' \
  310. -e 's/sh[234]/sh/' \
  311. -e 's/mips-.*/mips/' \
  312. -e 's/mipsel-.*/mipsel/' \
  313. -e 's/i[3-9]86/x86/' \
  314. )" >>prereq.mk
  315. echo "CURSES_LIBS:=${CURSES_LIBS}" >> $topdir/prereq.mk
  316. echo "CURSES_CFLAGS:=${CURSES_CFLAGS}" >> $topdir/prereq.mk
  317. if [ "$CC" = "clang" ]; then
  318. echo "HOST_CC:=${CC} -fbracket-depth=1024" >> $topdir/prereq.mk
  319. else
  320. echo "HOST_CC:=${CC}" >> $topdir/prereq.mk
  321. fi
  322. if [ "$CXX" = "clang++" ]; then
  323. echo "HOST_CXX:=${CXX} -fbracket-depth=1024" >> $topdir/prereq.mk
  324. else
  325. echo "HOST_CXX:=${CXX}" >> $topdir/prereq.mk
  326. fi
  327. echo "HOST_CFLAGS:=-O0 -g0 -fcommon" >> $topdir/prereq.mk
  328. echo "HOST_CXXFLAGS:=-O0 -g0 -fcommon" >> $topdir/prereq.mk
  329. echo 'LANGUAGE:=C' >> $topdir/prereq.mk
  330. echo 'LC_ALL:=C' >> $topdir/prereq.mk
  331. echo "_PATH:=$PATH" >> $topdir/prereq.mk
  332. echo "PATH:=${topdir}/scripts:/usr/sbin:$PATH" >> $topdir/prereq.mk
  333. echo "GIT:=$(which git 2>/dev/null)" >> $topdir/prereq.mk
  334. echo "export ADK_TOPDIR GIT SHA256 BASH SHELL" >> $topdir/prereq.mk
  335. # create temporary Makefile
  336. cat >Makefile.tmp <<'EOF'
  337. include ${ADK_TOPDIR}/prereq.mk
  338. all: test
  339. test: test.c
  340. @${HOST_CC} ${HOST_CFLAGS} -o $@ $^ ${LDADD}
  341. EOF
  342. # check if compiler works
  343. cat >test.c <<-'EOF'
  344. #include <stdio.h>
  345. int
  346. main()
  347. {
  348. printf("YES");
  349. return (0);
  350. }
  351. EOF
  352. printf " ---> checking if compiler is working.. "
  353. $MAKE --no-print-directory ADK_TOPDIR=$topdir -f Makefile.tmp >/dev/null 2>&1
  354. X=$(./test 2>/dev/null)
  355. if [ X$X != XYES ]; then
  356. echo Cannot compile a simple test programme.
  357. echo You must install a host make and C compiler.
  358. echo
  359. out=1
  360. else
  361. printf "okay\n"
  362. fi
  363. rm test.c test 2>/dev/null
  364. printf " ---> checking if zlib is installed.. "
  365. # check for zlib
  366. cat >test.c <<-'EOF'
  367. #include <stdio.h>
  368. #include <zlib.h>
  369. #ifndef STDIN_FILENO
  370. #define STDIN_FILENO 0
  371. #endif
  372. int
  373. main()
  374. {
  375. gzFile zstdin;
  376. char buf[1024];
  377. int i;
  378. zstdin = gzdopen(STDIN_FILENO, "rb");
  379. i = gzread(zstdin, buf, sizeof (buf));
  380. if ((i > 0) && (i < sizeof (buf)))
  381. buf[i] = '\0';
  382. buf[sizeof (buf) - 1] = '\0';
  383. printf("%s\n", buf);
  384. return (0);
  385. }
  386. EOF
  387. $MAKE --no-print-directory LDADD=-lz ADK_TOPDIR=$topdir -f Makefile.tmp >/dev/null 2>&1
  388. X=$(echo YES | gzip | ./test 2>/dev/null)
  389. if [ X$X != XYES ]; then
  390. echo Cannot compile a libz test program.
  391. echo You must install the zlib development package,
  392. echo usually called libz-dev, and the run-time library.
  393. echo
  394. out=1
  395. else
  396. printf "found\n"
  397. fi
  398. rm test.c test 2>/dev/null
  399. rm Makefile.tmp 2>/dev/null
  400. # error out on any required prerequisite
  401. if [ $out -ne 0 ]; then
  402. exit
  403. fi
  404. printf " ---> checking if bc is installed.. "
  405. host_build_bc=0
  406. if which bc >/dev/null 2>&1; then
  407. if ! echo quit|bc -q 2>/dev/null >/dev/null; then
  408. printf "not usable\n"
  409. host_build_bc=1
  410. else
  411. if bc -v 2>&1| grep -q BSD >/dev/null 2>&1; then
  412. host_build_bc=1
  413. printf "not usable\n"
  414. fi
  415. printf "found\n"
  416. fi
  417. else
  418. printf "not found\n"
  419. host_build_bc=1
  420. fi
  421. printf " ---> checking if bison is installed.. "
  422. host_build_bison=0
  423. if ! which bison >/dev/null 2>&1; then
  424. printf "not found\n"
  425. host_build_bison=1
  426. else
  427. printf "found\n"
  428. fi
  429. printf " ---> checking if bzip2 is installed.. "
  430. host_build_bzip2=0
  431. if ! which bzip2 >/dev/null 2>&1; then
  432. printf "not found\n"
  433. host_build_bzip2=1
  434. else
  435. printf "found\n"
  436. fi
  437. printf " ---> checking if file is installed.. "
  438. host_build_file=0
  439. if ! which file >/dev/null 2>&1; then
  440. printf "not found\n"
  441. host_build_file=1
  442. else
  443. printf "found\n"
  444. fi
  445. printf " ---> checking if flex is installed.. "
  446. host_build_flex=0
  447. if ! which flex >/dev/null 2>&1; then
  448. printf "not found\n"
  449. host_build_flex=1
  450. else
  451. printf "found\n"
  452. fi
  453. host_build_m4=0
  454. if ! which m4 >/dev/null 2>&1; then
  455. host_build_m4=1
  456. fi
  457. host_build_mkimage=0
  458. if ! which mkimage >/dev/null 2>&1; then
  459. host_build_mkimage=1
  460. fi
  461. printf " ---> checking if mksh is installed.. "
  462. host_build_mksh=0
  463. if ! which mksh >/dev/null 2>&1; then
  464. printf "not found\n"
  465. host_build_mksh=1
  466. else
  467. printf "found\n"
  468. fi
  469. printf " ---> checking if patch is installed.. "
  470. host_build_patch=0
  471. if ! which patch >/dev/null 2>&1; then
  472. printf "not found\n"
  473. host_build_patch=1
  474. else
  475. printf "found\n"
  476. fi
  477. printf " ---> checking if rsync is installed.. "
  478. host_build_rsync=0
  479. if ! which rsync >/dev/null 2>&1; then
  480. printf "not found\n"
  481. host_build_rsync=1
  482. else
  483. printf "found\n"
  484. fi
  485. host_build_tar=0
  486. if which tar >/dev/null 2>&1; then
  487. if ! tar --version 2>/dev/null|grep GNU >/dev/null;then
  488. host_build_tar=1
  489. fi
  490. else
  491. host_build_tar=1
  492. fi
  493. printf " ---> checking if xargs is installed.. "
  494. host_build_findutils=0
  495. if which xargs >/dev/null 2>&1; then
  496. if ! xargs --version 2>/dev/null|grep GNU >/dev/null;then
  497. printf "found but not usable\n"
  498. host_build_findutils=1
  499. else
  500. printf "found\n"
  501. fi
  502. else
  503. printf "not found\n"
  504. host_build_findutils=1
  505. fi
  506. printf " ---> checking if find is installed.. "
  507. if which find >/dev/null 2>&1; then
  508. if ! find --version 2>/dev/null|grep GNU >/dev/null;then
  509. printf "found but not usable\n"
  510. host_build_findutils=1
  511. else
  512. printf "found\n"
  513. fi
  514. else
  515. printf "not found\n"
  516. host_build_findutils=1
  517. fi
  518. printf " ---> checking if grep is installed.. "
  519. host_build_grep=0
  520. if which grep >/dev/null 2>&1; then
  521. if ! grep --version 2>/dev/null|grep GNU >/dev/null;then
  522. printf "found but not usable\n"
  523. host_build_grep=1
  524. else
  525. printf "found\n"
  526. fi
  527. else
  528. printf "not found\n"
  529. host_build_grep=1
  530. fi
  531. printf " ---> checking if gawk is installed.. "
  532. host_build_gawk=0
  533. if ! which gawk >/dev/null 2>&1; then
  534. printf "not found\n"
  535. host_build_gawk=1
  536. else
  537. printf "found\n"
  538. fi
  539. printf " ---> checking if sed is installed.. "
  540. host_build_sed=0
  541. if which sed >/dev/null 2>&1; then
  542. if ! sed --version 2>/dev/null|grep GNU >/dev/null;then
  543. printf "found but not usable\n"
  544. host_build_sed=1
  545. else
  546. printf "found\n"
  547. fi
  548. else
  549. printf "not found\n"
  550. host_build_sed=1
  551. fi
  552. printf " ---> checking if cpio is installed.. "
  553. host_build_cpio=0
  554. if which cpio >/dev/null 2>&1; then
  555. if ! cpio --version 2>/dev/null|grep GNU >/dev/null;then
  556. printf "found but not usable\n"
  557. host_build_cpio=1
  558. else
  559. printf "found\n"
  560. fi
  561. else
  562. printf "not found\n"
  563. host_build_cpio=1
  564. fi
  565. printf " ---> checking if xz is installed.. "
  566. host_build_xz=0
  567. if ! which xz >/dev/null 2>&1; then
  568. printf "not found\n"
  569. host_build_xz=1
  570. else
  571. printf "found\n"
  572. fi
  573. # optional
  574. host_build_cdrtools=0
  575. if ! which mkisofs >/dev/null 2>&1; then
  576. host_build_cdrtools=1
  577. fi
  578. host_build_genext2fs=0
  579. if ! which genext2fs >/dev/null 2>&1; then
  580. host_build_genext2fs=1
  581. fi
  582. host_build_lzma=0
  583. if ! which lzma >/dev/null 2>&1; then
  584. host_build_lzma=1
  585. fi
  586. host_build_zstd=0
  587. if ! which zstd >/dev/null 2>&1; then
  588. host_build_zstd=1
  589. fi
  590. host_build_lz4=0
  591. if ! which lz4c >/dev/null 2>&1; then
  592. host_build_lz4=1
  593. fi
  594. host_build_lzop=0
  595. if ! which lzop >/dev/null 2>&1; then
  596. host_build_lzop=1
  597. fi
  598. host_build_qemu=0
  599. if ! which qemu-img >/dev/null 2>&1; then
  600. host_build_qemu=1
  601. fi
  602. host_build_coreutils=0
  603. if which tr >/dev/null 2>&1; then
  604. if ! tr --version 2>/dev/null|grep GNU >/dev/null;then
  605. host_build_coreutils=1
  606. fi
  607. fi
  608. echo "config ADK_HOST_BUILD_TOOLS" > $topdir/target/config/Config.in.prereq
  609. printf "\t%s\n" "bool" >> $topdir/target/config/Config.in.prereq
  610. printf "\t%s\n" "default y" >> $topdir/target/config/Config.in.prereq
  611. # always required
  612. if [ $host_build_bc -eq 1 ]; then
  613. printf "\t%s\n" "select ADK_HOST_BUILD_BC" >> $topdir/target/config/Config.in.prereq
  614. fi
  615. if [ $host_build_bison -eq 1 ]; then
  616. printf "\t%s\n" "select ADK_HOST_BUILD_BISON" >> $topdir/target/config/Config.in.prereq
  617. fi
  618. if [ $host_build_bzip2 -eq 1 ]; then
  619. printf "\t%s\n" "select ADK_HOST_BUILD_BZIP2" >> $topdir/target/config/Config.in.prereq
  620. fi
  621. if [ $host_build_file -eq 1 ]; then
  622. printf "\t%s\n" "select ADK_HOST_BUILD_FILE" >> $topdir/target/config/Config.in.prereq
  623. fi
  624. if [ $host_build_flex -eq 1 ]; then
  625. printf "\t%s\n" "select ADK_HOST_BUILD_FLEX" >> $topdir/target/config/Config.in.prereq
  626. fi
  627. if [ $host_build_gawk -eq 1 ]; then
  628. printf "\t%s\n" "select ADK_HOST_BUILD_GAWK" >> $topdir/target/config/Config.in.prereq
  629. fi
  630. if [ $host_build_grep -eq 1 ]; then
  631. printf "\t%s\n" "select ADK_HOST_BUILD_GREP" >> $topdir/target/config/Config.in.prereq
  632. fi
  633. if [ $host_build_m4 -eq 1 ]; then
  634. printf "\t%s\n" "select ADK_HOST_BUILD_M4" >> $topdir/target/config/Config.in.prereq
  635. fi
  636. if [ $host_build_mkimage -eq 1 ]; then
  637. printf "\t%s\n" "select ADK_HOST_NEED_U_BOOT" >> $topdir/target/config/Config.in.prereq
  638. fi
  639. if [ $host_build_mksh -eq 1 ]; then
  640. printf "\t%s\n" "select ADK_HOST_BUILD_MKSH" >> $topdir/target/config/Config.in.prereq
  641. fi
  642. if [ $host_build_patch -eq 1 ]; then
  643. printf "\t%s\n" "select ADK_HOST_BUILD_PATCH" >> $topdir/target/config/Config.in.prereq
  644. fi
  645. if [ $host_build_rsync -eq 1 ]; then
  646. printf "\t%s\n" "select ADK_HOST_BUILD_RSYNC" >> $topdir/target/config/Config.in.prereq
  647. fi
  648. if [ $host_build_findutils -eq 1 ]; then
  649. printf "\t%s\n" "select ADK_HOST_BUILD_FINDUTILS" >> $topdir/target/config/Config.in.prereq
  650. fi
  651. if [ $host_build_sed -eq 1 ]; then
  652. printf "\t%s\n" "select ADK_HOST_BUILD_SED" >> $topdir/target/config/Config.in.prereq
  653. fi
  654. if [ $host_build_tar -eq 1 ]; then
  655. printf "\t%s\n" "select ADK_HOST_BUILD_TAR" >> $topdir/target/config/Config.in.prereq
  656. fi
  657. if [ $host_build_coreutils -eq 1 ]; then
  658. printf "\t%s\n" "select ADK_HOST_BUILD_COREUTILS" >> $topdir/target/config/Config.in.prereq
  659. fi
  660. if [ $host_build_cpio -eq 1 ]; then
  661. printf "\t%s\n" "select ADK_HOST_BUILD_CPIO" >> $topdir/target/config/Config.in.prereq
  662. fi
  663. if [ $host_build_xz -eq 1 ]; then
  664. printf "\t%s\n" "select ADK_HOST_BUILD_XZ" >> $topdir/target/config/Config.in.prereq
  665. fi
  666. # optional
  667. if [ $host_build_cdrtools -eq 1 ]; then
  668. printf "\t%s\n" "select ADK_HOST_BUILD_CDRTOOLS if ADK_HOST_NEED_CDRTOOLS" >> $topdir/target/config/Config.in.prereq
  669. fi
  670. if [ $host_build_genext2fs -eq 1 ]; then
  671. printf "\t%s\n" "select ADK_HOST_BUILD_GENEXT2FS if ADK_HOST_NEED_GENEXT2FS" >> $topdir/target/config/Config.in.prereq
  672. fi
  673. if [ $host_build_lzma -eq 1 ]; then
  674. printf "\t%s\n" "select ADK_HOST_BUILD_LZMA if ADK_HOST_NEED_LZMA" >> $topdir/target/config/Config.in.prereq
  675. fi
  676. if [ $host_build_zstd -eq 1 ]; then
  677. printf "\t%s\n" "select ADK_HOST_BUILD_ZSTD if ADK_HOST_NEED_ZSTD" >> $topdir/target/config/Config.in.prereq
  678. fi
  679. if [ $host_build_lz4 -eq 1 ]; then
  680. printf "\t%s\n" "select ADK_HOST_BUILD_LZ4 if ADK_HOST_NEED_LZ4" >> $topdir/target/config/Config.in.prereq
  681. fi
  682. if [ $host_build_lzop -eq 1 ]; then
  683. printf "\t%s\n" "select ADK_HOST_BUILD_LZOP if ADK_HOST_NEED_LZOP" >> $topdir/target/config/Config.in.prereq
  684. fi
  685. if [ $host_build_qemu -eq 1 ]; then
  686. printf "\t%s\n" "select ADK_HOST_BUILD_QEMU if ADK_HOST_NEED_QEMU" >> $topdir/target/config/Config.in.prereq
  687. fi
  688. # create Host OS symbols
  689. case $os in
  690. Linux)
  691. printf "\nconfig ADK_HOST_LINUX\n" >> $topdir/target/config/Config.in.prereq
  692. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  693. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  694. ;;
  695. Darwin)
  696. printf "\nconfig ADK_HOST_DARWIN\n" >> $topdir/target/config/Config.in.prereq
  697. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  698. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  699. ;;
  700. OpenBSD)
  701. printf "\nconfig ADK_HOST_OPENBSD\n" >> $topdir/target/config/Config.in.prereq
  702. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  703. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  704. ;;
  705. FreeBSD)
  706. printf "\nconfig ADK_HOST_FREEBSD\n" >> $topdir/target/config/Config.in.prereq
  707. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  708. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  709. ;;
  710. NetBSD)
  711. printf "\nconfig ADK_HOST_NETBSD\n" >> $topdir/target/config/Config.in.prereq
  712. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  713. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  714. ;;
  715. MirBSD)
  716. printf "\nconfig ADK_HOST_MIRBSD\n" >> $topdir/target/config/Config.in.prereq
  717. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  718. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  719. ;;
  720. Cygwin*)
  721. printf "\nconfig ADK_HOST_CYGWIN\n" >> $topdir/target/config/Config.in.prereq
  722. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  723. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  724. ;;
  725. esac
  726. if [ "$target" = "defconfig" ]; then
  727. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  728. exit 0
  729. fi
  730. if [ ! -f $topdir/.config ]; then
  731. # create a config if no exist
  732. touch .firstrun
  733. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk menuconfig
  734. else
  735. # scan host-tool prerequisites of certain packages before building.
  736. . $topdir/.config
  737. if [ -n "$ADK_PACKAGE_FIREFOX" ]; then
  738. NEED_RUST="$NEED_RUST firefox"
  739. fi
  740. if [ -n "$ADK_PACKAGE_FIREFOX" ]; then
  741. NEED_CARGO="$NEED_CARGO firefox"
  742. fi
  743. if [ -n "$ADK_PACKAGE_FIREFOX" ]; then
  744. NEED_CLANG="$NEED_CLANG firefox"
  745. fi
  746. if [ -n "$ADK_PACKAGE_FIREFOX" ]; then
  747. NEED_CBINDGEN="$NEED_CBINDGEN firefox"
  748. fi
  749. if [ -n "$ADK_PACKAGE_KODI" ]; then
  750. NEED_JAVA="$NEED_JAVA kodi"
  751. fi
  752. if [ -n "$ADK_PACKAGE_ICU4C" ]; then
  753. NEED_STATIC_LIBSTDCXX="$NEED_STATIC_LIBSTDCXX icu4c"
  754. fi
  755. if [ -n "$ADK_PACKAGE_XKEYBOARD_CONFIG" ]; then
  756. NEED_XKBCOMP="$NEED_XKBCOMP xkeyboard-config"
  757. fi
  758. if [ -n "$ADK_PACKAGE_FONT_BH_100DPI" ]; then
  759. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-100dpi"
  760. fi
  761. if [ -n "$ADK_PACKAGE_FONT_BH_75DPI" ]; then
  762. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-75dpi"
  763. fi
  764. if [ -n "$ADK_PACKAGE_FONT_BH_TYPE1" ]; then
  765. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-type1"
  766. fi
  767. if [ -n "$ADK_PACKAGE_FONT_BH_TTF" ]; then
  768. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-ttf"
  769. fi
  770. if [ -n "$ADK_PACKAGE_FONT_BH_LUCIDATYPEWRITER_100DPI" ]; then
  771. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-lucidatypewriter-100dpi"
  772. fi
  773. if [ -n "$ADK_PACKAGE_FONT_BH_LUCIDATYPEWRITER_75DPI" ]; then
  774. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bh-lucidatypewriter-75dpi"
  775. fi
  776. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_100DPI" ]; then
  777. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-100dpi"
  778. fi
  779. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_75DPI" ]; then
  780. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-75dpi"
  781. fi
  782. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_TYPE1" ]; then
  783. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-type1"
  784. fi
  785. if [ -n "$ADK_PACKAGE_FONT_ADOBE_100DPI" ]; then
  786. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-100dpi"
  787. fi
  788. if [ -n "$ADK_PACKAGE_FONT_ADOBE_75DPI" ]; then
  789. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-75dpi"
  790. fi
  791. if [ -n "$ADK_PACKAGE_FONT_XFREE86_TYPE1" ]; then
  792. NEED_MKFONTDIR="$NEED_MKFONTDIR font-xfree86-type1"
  793. fi
  794. if [ -n "$ADK_PACKAGE_FONT_MISC_MISC" ]; then
  795. NEED_MKFONTDIR="$NEED_MKFONTDIR font-misc-misc"
  796. fi
  797. if [ -n "$ADK_PACKAGE_LIBERATION_FONTS_TTF" ]; then
  798. NEED_MKFONTSCALE="$NEED_MKFONTSCALE liberation-fonts-ttf"
  799. fi
  800. if [ -n "$NEED_MKFONTDIR" ]; then
  801. if ! which mkfontdir >/dev/null 2>&1; then
  802. printf "You need mkfontdir to build $NEED_MKFONTDIR \n"
  803. out=1
  804. fi
  805. fi
  806. if [ -n "$NEED_MKFONTSCALE" ]; then
  807. if ! which mkfontscale >/dev/null 2>&1; then
  808. printf "You need mkfontscale to build $NEED_MKFONTSCALE \n"
  809. out=1
  810. fi
  811. fi
  812. if [ -n "$NEED_XKBCOMP" ]; then
  813. if ! which xkbcomp >/dev/null 2>&1; then
  814. printf "You need xkbcomp to build $NEED_XKBCOMP \n"
  815. out=1
  816. fi
  817. fi
  818. if [ -n "$NEED_JAVA" ]; then
  819. if ! which java >/dev/null 2>&1; then
  820. printf "You need java to build $NEED_JAVA \n"
  821. out=1
  822. fi
  823. fi
  824. if [ -n "$NEED_RUST" ]; then
  825. if ! which rustc >/dev/null 2>&1; then
  826. printf "You need rustc to build $NEED_RUST \n"
  827. out=1
  828. fi
  829. fi
  830. if [ -n "$NEED_CARGO" ]; then
  831. if ! which cargo >/dev/null 2>&1; then
  832. printf "You need cargo to build $NEED_CARGO \n"
  833. out=1
  834. fi
  835. fi
  836. if [ -n "$NEED_CLANG" ]; then
  837. if ! which clang-13 >/dev/null 2>&1; then
  838. printf "You need clang-13 to build $NEED_CLANG \n"
  839. out=1
  840. fi
  841. fi
  842. if [ -n "$NEED_CBINDGEN" ]; then
  843. if ! which cbindgen >/dev/null 2>&1; then
  844. printf "You need cbindgen to build $NEED_CBINDGEN \n"
  845. out=1
  846. fi
  847. fi
  848. if [ -n "$NEED_STATIC_LIBSTDCXX" ]; then
  849. cat >test.c <<-'EOF'
  850. #include <stdio.h>
  851. int
  852. main()
  853. {
  854. return (0);
  855. }
  856. EOF
  857. if ! $CXX -static-libstdc++ -o test test.c 2>/dev/null ; then
  858. printf "You need static version of libstdc++ installed to build $NEED_STATIC_LIBSTDCXX \n"
  859. out=1
  860. rm test test.c 2>/dev/null
  861. fi
  862. fi
  863. # error out
  864. if [ $out -ne 0 ]; then
  865. exit $out
  866. fi
  867. # start build
  868. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  869. fi